;**************************************
pro mc_fit_minimum,azitable_0,meanw50_0,plot0=plot0,$
                   ncoeff0=ncoeff0,periodic=periodic,$
                   stop=stop,aout=aout,print0=print0,$
                   lmin=lmin,width=width,amp1=amp1,amp2=amp2,amp3=amp3,$
                   nbin0=nbin0,xfit=xfit,yfit=yfit,oldwid=oldwid,$
                   delta20_0=delta20_0,ansa=ansa,amp4=amp4,$
                   bwid=bwid,bamp=bamp,$
                   amp_10=amp_10,amp_20=amp_20,amp_30=amp_30,amp_40=amp_40,$
                   trange=trange,amp_50=amp_50,thetas0=thetas0

if(n_params() le 0) then begin
    print,'mc_fit_minimum,azitable,iftable'
    print,'keywords:'
    print,'/plot -> plot fit'
    print,'ncoeff= number of f-coefficients (def=6)'
    print,'nbin  = values of fit points/degree (def=100)'
    print,'/periodic'
    print,' print ->  print + use as a plot title'
    print,'/stop'
    print,'  lmin,width,amp1,amp2,amp3'
    print,'  aout=[lmin,lmax,lhalf1,lhalf2,mini,maxi,meani,a20deg]'
    print,'  xfit,yfit'
    print,''
    print,' lmin = longitude of minimum'
    print,' width = FWHM = lhalf2 - lhalf1'
    print,' mini=Imin, maxi=Imax,  meani=0.5*(Imax+Imin)'
    print,' a20deg= I(lmin+delta20)/I(lmin)'
    print,' amp1       = (imax-imin)/(imax+imin)=0.5 AMP(skf2004)'
    print,' amp2       = (iansa-imin)/iansa'
    print,' amp3       = (I(min+delta20)-Imin)/Imin'
    print,' amp4       = (I(min+delta20)-Imin)/I(min+delta20)'
    print,' '
    print,'  oldwid:     I(270-oldwid)=I(270) '
    print,'  delta20 -> use Delta_theta for a20deg, amp3 (def=20)'
    print,'  bwid,bamp -> bamp=(I(min+bwid/2)-Imin)/I(min+bwid/2)
    print,'  amp_10=amp_10,amp_20=amp_20,amp_30=amp_30,amp_40=amp_40'
    print,' trange'
    return
endif



azitable=azitable_0
meanw50=meanw50_0
plot=0
if(keyword_set(plot0)) then plot=plot0

iperf=1.
ifmin50=min(meanw50)*iperf
ifmax50=max(meanw50)*iperf
amp_a=(ifmax50-ifmin50)/ifmin50

meani=0.5*(max(meanw50)+min(meanw50))
yr=meani+2*[min(meanw50)-meani,max(meanw50)-meani]
yr=yr*iperf
azitable0=azitable

title=''

amp_10=1.
amp_20=1.
amp_30=1.
amp_40=1.
amp_50=1.
lmin=-999.
lmax=999.


if(keyword_set(print0)) then title=print0

if plot then begin 
    plot,azitable,meanw50*iperf,psym=-6,xtitle='longitude',$
      ytitle='I/F',yr=yr,syms=.75,title=title
endif

if(keyword_set(periodic)) then begin
    azitable=[azitable-180,azitable,azitable+180]
    meanw50= [meanw50,meanw50,meanw50]
    if plot then     oplot,azitable,meanw50*iperf,psym=-6,syms=.4
endif

theta=azitable
l=where(theta ge -600 and theta le 600.,nl)
nl=n_elements(theta)
theta_min=round(theta[l[0]])
theta_max=round(theta[l[nl-1]])
nth=theta_max-theta_min+1
nth=nth>10   ; 260505
nbin=100
if(keyword_set(nbin0)) then nbin=nbin0
thetas=theta_min + findgen(nth*nbin+1)/nbin

if(keyword_set(thetas0)) then thetas=thetas0

nmid=(where(min(abs(thetas)) eq abs(thetas)))[0]
ncoeff=6
if(keyword_set(ncoeff0)) then ncoeff=ncoeff0

fourier_azscan,theta,iperf*meanw50,ncoeff,modelw50,coeffs
ym50=fourier_calc(thetas,coeffs)

xfit=thetas
yfit=ym50

mini=min(ym50)
maxi=max(ym50)

;serch minimum longitude
if(not keyword_set(trange)) then begin
    lmin=where(ym50 eq min(ym50))
    lmin=thetas(lmin(0))
endif

if(    keyword_set(trange)) then begin
    ind_use=where(thetas gt trange(0) and thetas le trange(1))
    lmin=where(ym50(ind_use) eq min(ym50(ind_use)))
    lmin=thetas(ind_use(lmin(0)))
    mini=min(ym50(ind_use))
endif
meani=0.5*(mini+maxi)



apu=abs(thetas-270)
ind=where(apu eq min(apu))
ind=ind(0)
ansa=ym50(ind)


if plot then begin
    oplot,thetas,ym50,col=2
    oplot,[-600,600],mini*[1,1],col=3,lines=1
    oplot,[-600,600],maxi*[1,1],col=3,lines=1
    oplot,[-600,600],meani*[1,1],col=3,lines=2
endif

;this in case of periodic
if(keyword_set(periodic)) then begin
if(lmin gt max(azitable0)) then lmin=lmin-180.
if(lmin gt max(azitable0)) then lmin=lmin-180.
if(lmin gt max(azitable0)) then lmin=lmin-180.
if(lmin gt max(azitable0)) then lmin=lmin-180.

if(lmin lt min(azitable0)) then lmin=lmin+180.
if(lmin lt min(azitable0)) then lmin=lmin+180.
if(lmin lt min(azitable0)) then lmin=lmin+180.
if(lmin lt min(azitable0)) then lmin=lmin+180.
endif

lmax=where(ym50 eq max(ym50))
lmax=thetas(lmax(0))
if(keyword_set(periodic)) then begin
if(lmax gt max(azitable0)) then lmax=lmax-180.
if(lmax gt max(azitable0)) then lmax=lmax-180.
if(lmax gt max(azitable0)) then lmax=lmax-180.
if(lmax gt max(azitable0)) then lmax=lmax-180.

if(lmax lt min(azitable0)) then lmax=lmax+180.
if(lmax lt min(azitable0)) then lmax=lmax+180.
if(lmax lt min(azitable0)) then lmax=lmax+180.
if(lmax lt min(azitable0)) then lmax=lmax+180.
endif

if plot then begin
    oplot,lmin*[1,1],[0,1],col=5,lines=2
    oplot,lmax*[1,1],[0,1],col=5,lines=2
ENDIF


;we have problems if no true lmin was not found 
;--> exit
lhalf1=0.
lhalf2=0.
oldwid=0.
amp4=0.
a20deg=0.

if(lmin le min(azitable0) or lmin ge max(azitable0)) then goto,no_lmin 

apu=abs(ym50-meani)
ind1=where(thetas le lmin and thetas gt min(azitable0))
apu1=apu(ind1)

lhalf1=where(apu1 eq min(apu1),count)
if(count le 0) then lhalf1=0
if(count ge 1) then begin
    lhalf1=lhalf1(0)
    lhalf1=thetas(ind1(lhalf1))
endif
IF PLOT THEN    oplot,lhalf1*[1,1],[0,1],col=5,lines=2


ind2=where(thetas ge lmin and thetas le max(azitable0))
apu2=apu(ind2)
lhalf2=where(apu2 eq min(apu2),count)
if(count le 0) then lhalf2=0
if(count ge 1) then begin
lhalf2=lhalf2(0)
lhalf2=thetas(ind2(lhalf2))
endif
IF PLOT THEN    oplot,lhalf2*[1,1],[0,1],col=5,lines=2

;a20deg= I(min+20)/I(min)

oldwid=0
;oldwid
;diff=abs(ym50-ansa)
;ind_use=where(thetas lt lmin and thetas gt lmin-60)
;diff=diff(ind_use)
;lon_use=thetas(ind_use)
;indwid=where(diff eq min(diff))
;indwid=indwid(n_elements(indwid)-1)
;oldwid=-(lon_use(indwid)-270.)


delta20=20.
if(keyword_set(delta20_0)) then delta20=delta20_0
apu=abs(thetas-lmin-delta20)
ind=where(apu eq min(apu))
ind=ind(0)

IF PLOT THEN plots,thetas(ind),ym50(ind),psym=2
a20deg=ym50(ind)/mini
amp4=(ym50(ind)-mini)/ym50(ind)

;-----------------------------------------------------
;10,20,30,40
apu=abs(thetas-lmin-10)
ind=where(apu eq min(apu))
ind=ind(0)
amp_10=ym50(ind)/mini
apu=abs(thetas-lmin-20)
ind=where(apu eq min(apu))
ind=ind(0)
amp_20=ym50(ind)/mini
apu=abs(thetas-lmin-30)
ind=where(apu eq min(apu))
ind=ind(0)
amp_30=ym50(ind)/mini
apu=abs(thetas-lmin-40)
ind=where(apu eq min(apu))
ind=ind(0)
amp_40=ym50(ind)/mini
apu=abs(thetas-lmin-50)
ind=where(apu eq min(apu))
ind=ind(0)
amp_50=ym50(ind)/mini
;-----------------------------------------------------


if(keyword_set(bwid)) then begin
    apu=abs(thetas-lmin-bwid/2)
    ind=where(apu eq min(apu))
    ind=ind(0)
    bamp=(ym50(ind)-mini)/ym50(ind)
endif


;if plot then plots,thetas(indwid),ym50(indwid),psym=1,syms=2,col=5

no_lmin:

if keyword_set(print0) then begin
    print,print0
    print,'Minimum at ',lmin
;    print,'FWHM',lhalf2-lhalf1,lmin-lhalf1,lhalf2-lmin
;    print,'h-AMP, a20deg',0.5*(maxi-meani)/meani,a20deg


endif

width=lhalf2-lhalf1
amp1=(meani-mini)/meani
amp2=(ansa-mini)/ansa
amp3=a20deg-1.

aout=[lmin,lmax,lhalf1,lhalf2,mini,maxi,meani,a20deg]

if(keyword_set(plot0)) then begin
    ff2='(f6.2)'    
    ff3='(f6.3)'    
    st1='LMIN ='+string(lmin,ff2)
    st2='IMIN ='+string(mini,ff3)
    st3='IMAX ='+string(maxi,ff3)
    st4='MEAN ='+string(meani,ff3)
    st44='ANSA ='+string(ansa,ff3)
    st5='FWHM ='+string(width,ff2)
    st6='AMP1 ='+string(amp1,ff3)
    st7='AMP2 ='+string(amp2,ff3)
    st8='AMP3 ='+string(amp3,ff3)
    label_data,.01,.9,[st1,st2,st3,st4,st44,st5,st6,st7,st8],len=1d-4,y_i=0.05
endif


if(keyword_set(stop)) then stop



end










