pro show_iss,rr0,xs0=xs0,ys0=ys0,title0=title0,taumax0=taumax0,$
             lit=lit,unlit=unlit,imatau=imatau,$
             r_lit=r_lit,r_unlit=r_unlit,r_tau=r_tau,$
             noplot=noplot,mark=mark,$,
             taureg=taureg,range=range,flit=flit,fulit=fulit,$
             reso=reso,stop=stop


if(N_PARAMS() LE 0) THEN BEGIN
    print,'show_iss,rr'
    print,'display Voyager PPS-TAU profile and' 
    print,'synthetic images made of lit and unlit ISS I/F profiles'
    print,'rr=[rmin,rmax] in 1000 km'
    print,''
    print,'/noplot -> do not plot,'
    print,'           used for returning (via keywords):'
    print,'           lit    =  image made of lit side I/F profile'
    print,'           unlit  =  image made of unlit side I/F profile'
    print,'           imatau =  image made of PPS occultation profile'
    print,'           keywords xs,ys specify image size'
    print,'           funlit=[min,max] range of inlit'
    print,'           flit=[min,max] range of  lit'
    print,'           /res ->show resonances (JS list from LC81)'
    print,'           taumax=taumax'
    print,' '
    print,'example:'
    print,'show_iss,[130,133],/res'
    return 
ENDIF

nypix=10
xs=800
if(keyword_set(xs0)) then xs=xs0
ys=300
if(keyword_set(reso)) then ys=600
if(keyword_set(ys0)) then ys=ys0


taumax=2.
if(keyword_set(taumax0)) then taumax=taumax0

;PPS optical depth
;restore,'/home/heikki/TB_IDL/pps_tau_vs_r.sav'
restore,'pps_tau_vs_r.sav'
r=r_pps/1000.
rr0=rr0*1.
ind=where(r ge rr0(0) and r le rr0(1),nxpix)
ima=fltarr(nxpix,nypix)
for i=0,nypix-1 do begin
    ima(*,i)=tau_pps(ind)
endfor
R_TAU=R

;imaging
;restore,'/home/heikki/TB_IDL/vgr_iss.save'
restore,'vgr_iss.save'

r_lit=[70000.+findgen(2000)*2.,r_lit,138702.+findgen(950)*2.]
if_lit=[findgen(2000)*0.,if_lit,findgen(950)*0.]

r_unlit=[70000.+findgen(2000)*2.,r_unlit]
if_unlit=[findgen(2000)*0.,if_unlit]

r_lit=r_lit/1000.
r_unlit=r_unlit/1000.


ind_lit=where(r_lit ge rr0(0) and r_lit le rr0(1),nxpix_lit)
ima_lit=fltarr(nxpix_lit,nypix)
for i=0,nypix-1 do begin 
    ima_lit(*,i)=if_lit(ind_lit)
endfor



ind_unlit=where(r_unlit ge rr0(0) and r_unlit le rr0(1),nxpix_unlit)
ima_unlit=fltarr(nxpix_unlit,nypix)
for i=0,nypix-1 do begin
    ima_unlit(*,i)=if_unlit(ind_unlit)
endfor

y2=spl_init(r_unlit,if_unlit)
unlit_tau=spl_interp(r_unlit,if_unlit,y2,r)

y2=spl_init(r_lit,if_lit)
lit_tau=spl_interp(r_lit,if_lit,y2,r)



if(keyword_set(stop)) then stop



if(not keyword_set(noplot)) then begin
;ima_lit=congrid(ima_lit,nxpix,nypix)
;ima_unlit=congrid(ima_unlit,nxpix,nypix)

ima_lit=sigrange(ima_lit,amin=amin1,amax=amax1)
ima_unlit=sigrange(ima_unlit,amin=amin2,amax=amax2)


if(keyword_set(funlit)) then begin
    amin2=funlit(0)
    amax2=funlit(1)
endif
if(keyword_set(flit)) then begin
    amin1=flit(0)
    amax1=flit(1)
endif


ff='(f6.4)'
title='VGR PPS: TAU=0.0-2.0   VGR ISS: Lit side I/F='+string(amin1,ff)+' - '+string(amax1,ff)+'    Unlit side I/F='+string(amin2,ff)+' - '+string(amax2,ff)     
if(keyword_set(title0)) then title=title0+title

ydum=lindgen(nypix)/nypix
nwin,xs=xs,ys=ys

!x.ticklen=-0.02
!y.ticklen=-0.01
tile_to_pos,1,3,page=[.05,.07,1.,.92],pos,fsize=1.
if(keyword_set(reso)) then tile_to_pos,1,4,page=[.05,.07,.95,.92],pos,fsize=1.

lask=0
if(keyword_set(reso)) then begin
lask=lask+1
endif


!p.position=pos(lask,*)
plot,r(ind),tau_pps(ind),ytitle='',xs=1,xr=rr,yr=[0,taumax],ys=1,noe=lask


if(keyword_set(reso)) then begin
    lrloc,xrtab,annotab,mtab,ttab,moon='all'
    xrtab=xrtab*100.
    indres=where(xrtab gt rr0(0) and xrtab lt rr0(1),rescount)


    if(rescount gt 0) then begin
        print,xrtab(indres)
        print,annotab(indres)

        sttab=strarr(rescount)
        for is=0,rescount-1 do begin
            sttab(is)=string(ttab(indres(is)),'(e10.2)')
        endfor

        lineid_plot,r(ind),0*tau_pps(ind),xrtab(indres),' '+annotab(indres)+' '+sttab,yr=[0,taumax],/noe,/noplot,pos=!p.position
    endif
    endif




if(keyword_set(mark)) then begin
    for i=0,n_elements(mark)-1 do begin
        oplot,mark(i)*[1,1],[0,taumax],col=120,lines=1,thick=2
    endfor
endif
if(keyword_set(taureg)) then begin
    ind=where(r gt taureg(0) and r lt taureg(1))
    taumean=mean(tau_pps(ind))
    xyouts,0.1,0.89,'<TAU>='+string(taumean,'(f5.2)'),/NORM,col=160
endif

lask=lask+1






!p.position=pos(lask,*)
!y.ticks=1
!y.tickname=[' ',' ']
 tvplot2,sigrange(ima_lit),xx0=r_lit(ind_lit),/noerase,/nonew,ytitle='I/F lit',yy=ydum
oplot,r_lit(ind_lit),(ima_lit(*,0)-amin1)/(amax1-amin1),col=100,lines=0

imin=0.002
imax=.2
aa=1./alog(imax/imin)
bb=-aa*alog(imin)
oplot,r_lit(ind_lit),aa*alog(ima_lit(*,0))+bb,col=0,lines=2
lask=lask+1

!p.position=pos(lask,*)
tvplot2,sigrange(ima_unlit),xx0=r_unlit(ind_unlit),/noerase,/nonew,xtitle='radius',ytitle='I/F unlit',yy=ydum
oplot,r_unlit(ind_unlit),(ima_unlit(*,0)-amin2)/(amax2-amin2),col=100,lines=0
aa=1./alog(imax/imin)
bb=-aa*alog(imin)

oplot,r_unlit(ind_unlit),aa*alog(ima_unlit(*,0))+bb,col=0,lines=2
!y.tickname=''
!y.ticks=0
!p.position=0.
!x.ticklen=0.02
!y.ticklen=0.02


xyouts,0.5,0.95,title,ali=0.5,/norm



endif

lit=congrid(ima_lit,xs,ys,/int)
unlit=congrid(ima_unlit,xs,ys,/int)
imatau=congrid(ima,xs,ys,/int)
end

